/*
 * AppFileReader.java
 * 
 * Created on Sep 19, 2012, 7:43:27 PM
 * 
 * Copyright(c) 2012 Carlos Eduardo Bernal Cárdenas. All Rights Reserved.
 * This software is the proprietary information of Carlos Eduardo Bernal Cárdenas.
 */
package googleplay.crawler.util;

import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * {Insert class description here}
 *
 * @author Carlos Eduardo Bernal Cárdenas
 * @version 1.0
 * @since Build Sep 19, 2012
 */
public class AppFileReader {

    private String filePath;
    private BufferedReader br;
    private DataInputStream in;
    private String newLine = null;

    public AppFileReader(String filePath) {
        this.filePath = filePath;
        // Open the file that is the first 
        // command line parameter
        FileInputStream fstream = null;
        try {
            fstream = new FileInputStream(filePath);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(AppFileReader.class.getName()).log(Level.SEVERE, null, ex);
        }
        // Get the object of DataInputStream
        in = new DataInputStream(fstream);
        br = new BufferedReader(new InputStreamReader(in));
    }

    public String getFilePath() {
        return filePath;
    }

    public void setFilePath(String filePath) {
        this.filePath = filePath;
    }

    public String getNextLine() {
        try {
            
            String oldLine = br.readLine();
            //Read File Line By Line
            if (oldLine == null) {
                //Close the input stream
                in.close();
            }
            return oldLine;
        } catch (IOException ex) {
            Logger.getLogger(AppFileReader.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }

    public void close() {
        try {
            if (in != null) {
                in.close();
            }
        } catch (IOException ex) {
            Logger.getLogger(AppFileReader.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}