/*
 * GooglePlayDownloader.java
 * 
 * Created on Sep 10, 2012, 8:27:49 PM
 * 
 * Copyright(c) 2012 Carlos Eduardo Bernal Cárdenas. All Rights Reserved.
 * This software is the proprietary information of Carlos Eduardo Bernal Cárdenas.
 */
package googleplaydownloader;

import com.gc.android.market.api.MarketSession;
import com.gc.android.market.api.model.Market;
import googleplay.crawler.util.AppFileReader;
import googleplay.crawler.util.DownloadAppThread;
import java.io.IOException;
import java.net.MalformedURLException;

/**
 *
 * @author Carlos Eduardo Bernal Cárdenas
 * @version 1.0
 * @since Build Sep 10, 2012
 */
public class GooglePlayDownloader {
    
    private static String appId;

    public String getAppId() {
        return appId;
    }

    public static void setAppId(String idApp) {
        GooglePlayDownloader.appId = idApp;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws MalformedURLException, IOException, InterruptedException {
        String androidId = args[0]; //Android device id
        String user = args[1]; //Gmail account (e.g., pepe@gmail.com)
        String password = args[2]; //Gmail account password
        String downloadPath = args[3]; // Output directory

        MarketSession session = new MarketSession(false);
        session.login(user, password, androidId);

        String filePath = args[4]; //path to file with apps id. Each line in the file should have the id of an android id


        AppFileReader afr = new AppFileReader(filePath);
        String packageName;
        while ((packageName = afr.getNextLine()) != null) {

            Market.AppsRequest appsRequest = Market.AppsRequest.newBuilder().setQuery("pname:" + packageName).setStartIndex(0).setEntriesCount(10).setWithExtendedInfo(true).build();
            session.append(appsRequest, new MarketSession.Callback<Market.AppsResponse>() {

                @Override
                public void onResult(Market.ResponseContext context, Market.AppsResponse response) {
                    if (response != null && response.getAppCount() > 0) {
                        setAppId(response.getApp(0).getId());
                    } else {
                        System.out.println("Nothing found...");
                    }
                }
            });
            session.flush();


            Thread thread1 = null;
            if (GooglePlayDownloader.appId != null) {
                thread1 = new DownloadAppThread(packageName, GooglePlayDownloader.appId, user, password, androidId, downloadPath);
                if (thread1.getState() == Thread.State.NEW || thread1.getState() == Thread.State.TERMINATED) {
                    thread1.start();
                }
               
                thread1.sleep(2 * 60 * 1000);
            }
        }
        afr.close();
    }
    
}
